Description

| am seeing warnings like the following in my private signal strength jobs:

AdcNoiseSignalFinder::update: WARNING: Channel 12320 exiting after 20 loops.

The problem is intermittent, i.e. sometimes appears and sometimes not when processing the same data with the same configuration.
When it does occur, it is seems to be all channels in many events.

| suspect this is giving a bias in my signal strength results giving incorrectly low values when ROls are lost.

| ran with valgrind and its output is attached. | inspected to code for the ROI finder and | don't think the problem is there bu in the data
passed to the tool.

| don't know if this issue can or will affect (or not affect) production reconstruction. The ROI finder is not used there.
The directory where | ran valgrind is

/nashome/d/dladams/dev/dudev03/np04-prod/nov19/roi/local_roiplots/dpcr_apaiz/trig13/run006118evis000000-003000proc000010
This is a build of dunetpc based on larsoft v08_36_02 using clang (c2) on slf6. | have not yet observed the problems elsewhere.

History

#1 - 12/16/2019 06:16 PM - David Adams

Here is the command | use to run valgrind:

ups list -aK+ valgrind
setup valgrind v3_14_0

valgrind --tool=memcheck —--leak-check=no --track-origins=yes —-num-callers=20 --log-file=valgrind.out --error-
limit=no --suppressions=${ROOTSYS}/etc/valgrind-root.supp lar -c run.fcl -S infiles.txt -n 1 --nskip 0 —--no-ou
tput

#2 - 12/16/2019 06:28 PM - David Adams
- File valgrind_23767_slf7_gcc v083602.out added

I was running OK with a gcc build of v08_36_02 for a while but then the problem popped up again. | attach valgrind output.

#3 - 12/17/2019 08:17 AM - David Adams

The slf7 jobs are run in

/nashome/d/dladams/dev/dudev02/np04-proc/dec2019/roi/local_roiplots/dpcr_apalz/trigl3/run010527evts000000-0010
00proc000005

#4 - 12/17/2019 09:24 AM - David Adams

| see one problem is in PdspNoiseRemoval service. In a couple places the input waveform is copied to local vector with size fftSize from the LAr FFT
service. As discussed in #23671, my jobs are picking up a fixed value for fftSize from fcl. That value was too small for jobs with widow length 15000
ticks (7.5 ms) leading to crashes. The code was modified to abort in that case. | set the value to 16384 so 7.5 ms runs would not abort. The crash
here is for a 3 ms job (6000 ticks) and arises because the destination waveform is padded to its length but the padding fails if ftSize is more than
twice the input length.

I have modified PdspNoiseRemoval to also abort if the latter occurs and moved the copy, pad and checking to a dedicated function

#5 - 12/17/2019 09:39 AM - David Adams

The above change is committed to dunetpc. Jingbo, could you have a look and indicate if all is OK. If | don't hear back in couple days, and the
problem does not pop up again in my running, | will go ahead and close this ticket.

#6 - 12/17/2019 09:47 AM - David Adams

- File valgrind_23767_slf7_gcc v083602_fix1.out added

I ran valgrind with the above fix and now get only three errors which are not in DUNE code. | attach the valgrind report.

Kyle, could you pass the report along to the relevant person in art? Again, if | don't hear back in a couple days, | will close this report.

#7 - 12/17/2019 11:06 AM - Kyle Knoepfel

David, the memory warning about artdaq's quick vec is a consequence of how ROOT reads data products via its dictionary mechanisms. It is not a
problem per se and can be ignored.

#8 - 12/18/2019 03:29 PM - David Adams

Christoph reported a dunetpc Cl test was failing after the above commit.

Looking at the code, | see the new function in noise removal is taking the waveforms by copy instead of reference. | have fixed this and am testing.
#9 - 12/18/2019 05:53 PM - David Adams

| have confirmed results look reasonable with updated code and have committed the fix.

Christoph, please let us know if the ClI job looks ok or not.

#10 - 12/19/2019 03:08 AM - Christoph Alt

Cl test with the current head of dunetpc develop (revision e2a10fb9) is OK.
#11 - 12/19/2019 01:25 PM - David Adams

Thank you Christoph and sorry for the trouble.

| am declaring victory and closing this.

#12 - 12/20/2019 03:47 PM - David Adams

- Status changed from New to Closed

Run 4560 event 38 APA 2 has one (or more) channels that decode with too few ticks and the event is caught by the abort in PdspNoiseRemoval tool
(not service as indicated above). Presumably we should skip this event.

Now | close the ticket as promised earlier.

#13 - 12/27/2019 01:12 PM - David Adams

| have added a valgrind suppressions file to dunetpc that masks the memcheck errors discussed above and updated the instructions at
https://wiki.dunescience.org/wiki/Debugging_ DUNE_far_detector_SW#valgrind.

Files

valgrind.out 133 MB 12/15/2019 David Adams
valgrind_23767_slf7_gcc_v083602.out 369 KB 12/17/2019 David Adams
valgrind_23767_slf7_gcc_v083602_fix1.out 27.7 KB 12/17/2019 David Adams
